### Versuchscode
### Der gesamte Code in dieser Datei stellt alle unsere Versuche dar, die entweder funktionierten, aber ungebräuchlich waren,
### die vollständig gescheitert sind, und alle Versuche, die uns als Übung und zum Verständnis der Materie dienten.


### Allgmeine Versuche #################################################

### Importieren des Dataframes_all und jeweiliges aufsplitten in Länder spezifische Dataframes
df = pd.read_pickle(".\dataframe_all")
uk_dataframe = df[df["Country"]=="UK"]


us_dataframe = df[df["Country"]=="US"]


### Umwandlung einer gecrawlten csv Datei in ein Dataframe mit entsprechender Spaltenbenennung.
data = pd.read_csv("extracted_website_downloads_2017-12-21.csv" , names=['ID', 'URL', 'Country', 'Text'])
data1 = pd.DataFrame(data)
data1.to_csv('example.csv')
print(data1)


### Implementierung einer Counterfunktion, um die Anzahl der Artikel pro Land zu zählen
counter = Counter(data1['Country'])
country_names = counter.keys()
country_counts = counter.values()


### Erster Versuch einer Visualiserung für die Ergebnisse der gezählten Artikel pro Land.
indexes = np.arange(len(country_names))
width = 1.5
plt.bar(indexes, country_counts, width)
plt.xticks(indexes + width * 0.5, country_names)
plt.show()


### Erster Versuch um Stopwörter aus dem Dataframe zu entfernen. Allerdings funktioniert dies nicht, da Satzzeichen,
### wie "\xa0The" überbleiben.
stop_words = set(stopwords.words("english"))
Test = (data1['Text'].values.astype('U'))
print(Test)
Test1 = pd.DataFrame(Test, columns=['test'])
print(Test1)




### GENSIM #############################################################

from gensim import corpora, models, similarities

#texts ist wie filtered_single_words eine Liste aus Listen mit einzelnen Wörtern als string
texts = [[word for word in article.split()] for article in filtered_text]
dictionary = corpora.Dictionary(texts)
#print(dictionary)


bow_gensim = [dictionary.doc2bow(text) for text in texts]
#print(bow_gensim) 
#Liste aus Listen, innere Liste aus Tupeln, (7, 1): Wort mit ID 7 kommt 1x vor



tfidf_initialize = models.TfidfModel(bow_gensim)
tfidf_gensim = tfidf_initialize[bow_gensim]
for doc in tfidf_gensim:
    print(doc)             
    #gibt mehrere Listen (132?) mit Tupeln zurück, (2, x): Wort mit ID 2 hat x als tfidf-Wert


lsi_initialize = models.LsiModel(tfidf_gensim, id2word=dictionary, num_topics=100) # initialize an LSI transformation
lsi_gensim = lsi_initialize[tfidf_gensim] # create a double wrapper over the original corpus: bow->tfidf->fold-in-lsi
#lsi_initialize.print_topics(5)


for doc in lsi_gensim:
    print(doc)       
    #gibt mehrere Listen (132?) mit Tupeln zurück, (2, x): Wort mit TOPIC 2 hat x als lsi-Wert



#We would like to sort our articles in decreasing order of relevance to a query. 
#We only concentrate on a single aspect of possible similarities: on apparent semantic relatedness of their texts/words.
#To prepare for similarity queries, we need to enter all documents which we want to compare against subsequent queries.

#Articles that are transformed to LSI space will be indexed:
indexed_lsi = similarities.MatrixSimilarity(lsi_gensim)

# class similarities.MatrixSimilarity is only appropriate when whole set of vectors fits into memory, otherwise use 
# the similarities.Similarity class. This class operates in fixed memory, by splitting the index across multiple files on disk,
# called shards. It uses similarities.MatrixSimilarity and similarities.SparseMatrixSimilarity internally, so it is still fast, 
# although slightly more complex.

# The query:
query = "trump"
query_bow = dictionary.doc2bow(query.lower().split())
# im Beispiel wird direkt von BOW zu LSI gewandelt, ohne tfidf, sonst kommt kein vernünftiges Ergebnis im nächsten Schritt
#query_bow = [dictionary.doc2bow(query.lower().split()) for i in query]
#tfidf_initialize = models.TfidfModel(query_bow)
#query_tfidf = tfidf_initialize[query_bow]
query_lsi = lsi_initialize[query_bow] # convert the query to LSI space


# to obtain similarities of query against indexed articles:
sims_unsorted = indexed_lsi[query_lsi] # perform a similarity query against the corpus
#print(list(enumerate(sims_unsorted))) # prints (document number, document similarity)
#Cosine measure returns similarities in the range <-1, 1> (the greater, the more similar)

# sort these similarities into descending order, and obtain the final answer to the query
sims = sorted(enumerate(sims_unsorted), key=lambda item: -item[1])
#print(sims) 
# prints sorted by similarity score (document number, similarity score)



### PREPROCESSING #############################################################



### Preprocessing - in einer Funktion zusammengefasst ###
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize
from nltk.stem import PorterStemmer
import string

# Beide Schritte kann man zur einen Funktion zusammenfassen.
# --Preprocessing: Zeichen entfernen, Stopwords entfernen.

def text_process(article):
    ps = PorterStemmer()
    nopunc = [char for char in article if char not in string.punctuation] # char-zeichen
    nopunc = "".join(nopunc) #führen alle Zeichen wieder zusammen

    filtered_words = [word for word in nopunc.split() if word.lower() not in stopwords.words ("english")]
    x=0
    for w in filtered_words:
        filtered_words[x] = ps.stem(w)
        x = x + 1
    return filtered_words

data_frame["Article"].head().apply(text_process)



####### Preprocessing - WORKING VERSION 1 ######
##### Delete Stop Words & Punctuation #####
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize
from nltk.stem import PorterStemmer
import string
    
stop_words = set(stopwords.words("english"))
# raw_text ist jetzt eine Liste aus strings, jeder string ein Artikel:
raw_text = list((data_frame["Article"].values.astype("U")))
# raw_text_liste ist eine Liste aus Listen mit string-Elementen,jede innere Liste ist ein Artikel
raw_text_liste = [[art] for art in raw_text] 

k=0
ps = PorterStemmer()
for i in raw_text_liste:
    raw_str = "".join(i)
    raw_words = word_tokenize(raw_str) # split to words
    # Stop words and punctuation
    nonpunc = [char for char in raw_words if char not in string.punctuation]
    nonpunc = " ".join(nonpunc)
    raw_words = word_tokenize(nonpunc)
    filtered_words = [w for w in raw_words if w.lower() not in stop_words]
    #Stemming
    x=0
    for w in filtered_words:
        filtered_words[x] = ps.stem(w)
        x = x+1
        
    raw_text_liste[k] = filtered_words
    k = k+1
    filtered_text = raw_text_liste
    
z=0
for l in filtered_text:
    filtered_text[z] = " ".join(l)
    z=z+1
filtered_text  # Liste aus clean strings, jeder string ein clean Artikel


from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize
import string
import unicodedata
import sys
from nltk.stem.wordnet import WordNetLemmatizer
from nltk import pos_tag
from nltk.corpus import wordnet
from collections import Counter 

####### Preprocessing - 1 Version ######
##### Delete Stop Words & Punctuation #####

def longPreprocessing(big_dataframe):
    lemmatizer = WordNetLemmatizer()
    stop_words = set(stopwords.words("english"))

    # Iteriert über alle Artikeln und übergibt Zeilenindex von einem Artikel (art_index) und Artikel selbst (art)
    for article_index,article in big_dataframe["Article"].head(n=100).astype("U").iteritems():
    
        # Checkt jedes Zeichen, ob es ein Satzzeichen ist
        nopunc = [char for char in article if char not in string.punctuation]
    
        # Alle Zeichen wieder zurückjoinen
        nopunc = "".join(nopunc)
    
        # löscht alle Stopwörter
        filtered_words = [word for word in nopunc.split() if word.lower() not in stop_words] # filtered_words ist eine Liste aus einzelnen Wörter

        x=0
        for word in filtered_words:
            filtered_words[x] = lemmatizer.lemmatize(word)
            x = x+1
    
        filtered_text = " ".join(filtered_words)

        # Löscht alle Unicode-Zeichen
        tbl = dict.fromkeys(i for i in range(sys.maxunicode)
                          if unicodedata.category(chr(i)).startswith("P"))
    
        big_dataframe.set_value(article_index, "Article", filtered_text.translate(tbl))
    return big_dataframe

## Preprocessing - 2 Version ##
def shortPreprocessingOLD(b_dataframe):

    lemmatizer = WordNetLemmatizer()
    stop_words = set(stopwords.words("english"))

    # Iteriert über alle Artikeln und übergibt Zeilenindex von einem Artikel (art_index) und Artikel selbst (art)
    for article_index,article in b_dataframe["Article"].head(n=100).astype("U").iteritems():
        
        # Checkt jedes Zeichen, ob es ein Satzzeichen ist
        nopunc = [char for char in article if char not in string.punctuation]
    
        # Alle Zeichen wieder zurückjoinen
        nopunc = "".join(nopunc)
    
        filtered_words = [lemmatizer.lemmatize(word) for word in nopunc.split() if word.lower() not in stop_words]
        
        
        filtered_text = " ".join(filtered_words)

        # Löscht alle Unicode-Zeichen
        tbl = dict.fromkeys(i for i in range(sys.maxunicode)
                          if unicodedata.category(chr(i)).startswith("P"))
    
        big_dataframe.set_value(article_index, "Article", filtered_text.translate(tbl))
    return b_dataframe

    import timeit

# Aus Pickle-Datei einlesen
df = pd.read_pickle(".\dataframe_all")

# Zeit messen (Perfomance)
start_time = timeit.default_timer()
shortPreprocessing(df)
print(timeit.default_timer() - start_time)






### BOW #############################################################

from sklearn.feature_extraction.text import CountVectorizer #hiermit kann man an jedem Wort dranschreiben, wie of es vorkommt.

# list of text documents
text = data_frame.loc[1,"Article"].split()
# create the transform
vectorizer = CountVectorizer(stop_words="english")
# tokenize and build vocab
vectorizer.fit_transform(text)
# encode document
vector = vectorizer.transform(text)
vectorizer.vocabulary_ #without stop words


##### BOW - WORKING VERSION #### 
# A bag-of-words is a representation of text that describes the occurrence of words within a document.
from sklearn.feature_extraction.text import CountVectorizer

to_bow= CountVectorizer(stop_words="english").fit(filtered_text)
print(len(to_bow.vocabulary_))
to_bow.vocabulary_
bow_all=to_bow.transform(filtered_text)
print(bow_all)
print(bow_all.shape) # damit kann man sehen, wie groß unsere Bow-Transformation ist (wie viele Artikel, wie viele wörter in allen Artikeln)
print(to_bow.get_feature_names()[3711]) # gibt das wort mit dem Index 3711 aus
print(to_bow.vocabulary_.get("the")) # gibt index von The



### PART-OF-SPEECH #############################################################

### PartofSpeech
### https://www.ling.upenn.edu/courses/Fall_2003/ling001/penn_treebank_pos.html
### Hier werden die W#einzelnen Wörter tokenized und anschließend mit einem pos tag versehen.
### Da der Text nicht komplett bereinigt ist, tauchen Satzzeichen etc. ebenfalls in der Ausgabe mit einem pos tag auf. 
### Das Versuchen Chunking zu implementieren hat nicht funktioniert, sodass dieser Code auskommentiert wurde. 
custom_sent_tokenizer = PunktSentenceTokenizer(str1)
tokenized = custom_sent_tokenizer.tokenize(str1)

def process_content():
    try:
        for i in tokenized:
            words = nltk.word_tokenize(i)
            tagged = nltk.pos_tag(words)
                        
            ##### Chunking
            
            #chunkGram = r"""Chunk: {<RB.?>*<VB.?>*<NNP>+<NN>?}"""
            
            #chunkParser = nltk.RegexpParser(chunkGram)
            #chunked = chunkParser.parse(tagged)
            
            #chunked.draw()
            
            print(tagged)
            
    except Exception as e:
        print(str(e))
        
process_content()



### WORDNET #############################################################

### WordNet (Wortähnlichkeiten, Synonyme etc...)
syns = wordnet.synsets("house")

### Gibt das vorher definierte Wort zurück 

print(syns[0].lemmas()[0].name())

### Gibt die Definition des Wortes zurück, wie es im Gutenberg steht. 
### Beispiel: house = a dwelling that serves as living quarters for one or more families

print(syns[0].definition())

### Exemplarische Sätze in dennen das vorher definierte Wort drin vor kommt.
### Beispiel: 'he has a house on Cape Cod', 'she felt she had to get out of the house'

print(syns[0].examples())

### Eine Funktion um die Synonyme und Antonyme für ein Wort heraus zu finden. 
### Dabei wird das Wort vorher eingegeben und nach dem Durchlauf der Funktion seine Synonyme und Antonyme raus gegeben. 
### Beispiel (true): {'truthful', 'confessedly', 'unfeigned', 'reliable', 'admittedly', 'on-key', 'dead_on_target', 
### 'true', 'genuine', 'dependable', 'honest', 'lawful', 'avowedly', 'rightful', 'true_up', 'straight'}
### sowie, {'false', 'untruthful'}

synonyms = []
antonyms = []

for syn in wordnet.synsets("true"):
    for l in syn.lemmas():
        synonyms.append(l.name())
        if l.antonyms():
            antonyms.append(l.antonyms()[0].name())
            
print(set(synonyms))
print(set(antonyms))

### Berechnet die Wortähnlichkeit zweier Wörter.
### Beispiel ship und cat sind zu 32% ähnlich. ship und boat zu 90%.

w1 = wordnet.synset("ship.n.01")
w2 = wordnet.synset("boat.n.01")
print(w1.wup_similarity(w2))



### TFIDF #############################################################

#TFIDF-Beispiel
from sklearn.feature_extraction.text import TfidfVectorizer #hiermit kann man Gewichtungen für Wörter berechnen
# list of text documents
text = ["The quick brown fox jumped over the lazy dog.", "The dog.", "The fox"]

# create the transform
vectorizer = TfidfVectorizer()
# tokenize and build vocab
vectorizer.fit(text)
# summarize
print(vectorizer.vocabulary_)
print(vectorizer.idf_)
# encode document
vector = vectorizer.transform([text[0]])
# summarize encoded vector
print(vector.shape)
print(vector.toarray())
vectorizer.vocabulary_
vectorizer.idf_ 
# The inverse document frequencies are calculated for each word in the vocabulary,
# assigning the lowest score of 1.0 to the most frequently observed word: “the” at index 7.
vector = vectorizer.transform([text[0]])
vector.shape
vector.toarray()
# The scores are normalized to values between 0 and 1 
# and the encoded document vectors can then be used directly with most machine learning algorithms.


# Schritt 2 ### VEKTORISIERUNG ###
# Aktuell liegen unsere Nachrichten als eine Liste von Tokens vor. 
# Nun muss man jede Nachricht in einen Vektor umwandeln, um mit dem 
# Scikit learn Algorithmus arbeiten zu können.

# Dazu verwenden wir TF IDF. Schritte:
# 1) Zähle, wie häufig ein Wort in jeder Nachricht vorkommt (Term Frequency)
# 2) Gewichte die Anzahl, wo dass häufige Wörter ein niedrigeres Gewicht erhalten.
# (Inverse Document Frequency)
# 3) Normalisiere den Vektor in Einheitslänge, um von der Länge
# des Originaltexts zu abstrahieren.

#### TF IDF  - WORKING VERSION #####
## Gewichtung von Wörtern: Auswerten, wie wichtig ein Wort in einem Dokument
# in einem Corpus ist. Die Wichtigkeit steigt proportional zur Anzahl
# der Erscheinungen des Worts im Dokument, doch wird ausgeglichen durch
# die Häufigkeit des Worts in gesamten Corpus. TF IDF wird häufig bei
# Suchmaschinen verwendet, um die WIchtigkeit eines Dokumentes für eine 
# Nutzerabfrage zu beurteilen.
# Eine der einfachsten Ranking-Funktionen wird berechnet, indem die TF IDF
# für jedes WOrt in der Suchanfrage summiert werden. Darüber hinaus gibt es 
# deutlisch koplexere Ranking-Funktionen basierend auf diesem einfachen Modell.

# TF = wie häufig erscheint ein Wort in einem Dokument / Anzahl aller Wörter
# IDF = Log der Gesamtzahl an Dokus / Anzahl der Dokus, die ein bestimmten Wort enthalten
# TF IDF = TF * IDF

from sklearn.feature_extraction.text import TfidfTransformer
tfidf_transformer = TfidfTransformer().fit(bow_all) # legt Transformer an
# Nun transformieren wir alle Nachrichten in tfidf Corpus 
tfidf_all = tfidf_transformer.transform(bow_all)
# Check, ob wir richtig transformiert haben
print(tfidf_all.shape)
# (gesamtzahl von Nachrichten, gesamtzahl von einzigartigen wörter)
print(tfidf_all)


#Get the most (10) weighted words with tfidf for the 2. article - Index 1.
weights = np.asarray(tfidf_all[1].mean(axis=0)).ravel().tolist()
weights_df = pd.DataFrame({'Word': to_bow.get_feature_names(), 'Weight': weights})
help_df = weights_df[weights_df["Weight"]>0].sort_values(by='Weight', ascending=False)
help_df[:10]

## Visualisation. the first 10 most weighted words.
ax = help_df[:10].plot(x="Word",kind='bar', title='1 Article Word TF-IDF Values',
            figsize=(10,6), width=.8, fontsize=14, rot=45 )
ax.title.set_size(20)

print(to_bow.get_feature_names()[3081]) # gibt das wort mit dem Index 3081 aus
print(to_bow.vocabulary_.get("parti")) # gibt index von The


### TFIDF Vectorizer ##
# As tf–idf is very often used for text features, there is also another class
# called TfidfVectorizer that combines all the options of CountVectorizer
# and TfidfTransformer in a single model.
from sklearn.feature_extraction.text import TfidfVectorizer

# Define the TFIDF vectorizer that will be used to process the data
tfidf_vectorizer = TfidfVectorizer()
# Apply this vectorizer to the full dataset to create normalized vectors
tfidf_matrix = tfidf_vectorizer.fit_transform(filtered_text)
# Get the names of the features
features = tfidf_vectorizer.get_feature_names()
#get the row that contains relevant vector
#row = data_from_csv.index.get_loc("1.513815e+09")
#Create a series from the sparse matrix
d = pd.Series(tfidf_matrix.getrow(0).toarray().flatten(), index = features).sort_values(ascending=False)

ax = d[:10].plot(kind='bar', title='1 Article Word TF-IDF Values',
            figsize=(10,6), width=.8, fontsize=14, rot=45 )
ax.title.set_size(20)




###Hier bekommen wir immer einen Memory Error, da die Datenanzahl zu hoch ist. 
###Das verwenden von HashingVectorizer() führt ebenfalls zu einem Memory Error.
from sklearn.feature_extraction.text import HashingVectorizer
vectorizerHash = HashingVectorizer(lowercase=False)
Vectores22 = vectorizerHash.fit_transform([chunk["Article"] for chunk in list_df]).todense()

vocab1 = vectorizer.get_feature_names()

for f in Vectores: 
   print(euclidean_distances(Vectores[0], f))


# Gibt Dataframe zurück wo jede Zeile für ein Wort steht, Spalten: word_nr, tfidf, term
def tfidf_df_per_art(article_nr):
    a_nr = filtered_text_df.index.get_loc(article_nr)
    wn = pd.Series(tfidf_all2.getrow(a_nr).toarray().flatten()).sort_values(ascending=False)
    f = pd.Series(tfidf_all2.getrow(a_nr).toarray().flatten(), index = features).sort_values(ascending=False)
    df_wn = pd.DataFrame({"tfidf": wn}).reset_index()
    df_f = pd.DataFrame(f).reset_index()
    df_wn['term'] = df_f['index']
    df_wn.rename(columns={"index": "word_nr"}, inplace=True)
    #df_n.set_index("term", inplace=True)
    return df_wn
# tfidf_df_per_art ohne def, weil es bei der Nutzung des Ergebnis-Dataframes Probleme gab
# gibt wieder Dataframe zurück wo jede Zeile für ein Wort steht, Spalten: word_nr, tfidf, term

a_nr = filtered_text_df.index.get_loc(21)
wn = pd.Series(tfidf_all2.getrow(a_nr).toarray().flatten()).sort_values(ascending=False)
f = pd.Series(tfidf_all2.getrow(a_nr).toarray().flatten(), index = features).sort_values(ascending=False)

df_wn = pd.DataFrame({"tfidf": wn}).reset_index()
df_f = pd.DataFrame(f).reset_index()

df_wn['term'] = df_f['index']
df_wn.rename(columns={"index": "word_nr"}, inplace=True)
#df_n.set_index("term", inplace=True)

#wn_liste_head = list(df_wn["word_nr"].head())
tf_liste_head = list(df_wn["tfidf"].head())

wn_liste = list(df_wn["term"])
tf_liste = list(df_wn["tfidf"])

zipped = list(zip(wn_liste, tf_liste))
#zipped_head = list(zip(wn_liste_head, tf_liste_head))






### KMEANS-CLUSTERING ###############################################################

## Clustering 
import matplotlib.pyplot as plt
from sklearn.feature_extraction.text import TfidfVectorizer
from sklearn.cluster import KMeans
from sklearn.decomposition import PCA
from sklearn.manifold import TSNE

num_clusters = 10
num_seeds = 10
max_iterations = 300
labels_color_map = {
    0: '#20b2aa', 1: '#ff7373', 2: '#ffe4e1', 3: '#005073', 4: '#4d0404',
    5: '#ccc0ba', 6: '#4700f9', 7: '#f6f900', 8: '#00f91d', 9: '#da8c49'
}
pca_num_components = 2
tsne_num_components = 2

# create k-means model with custom config
clustering_model = KMeans(
    n_clusters=num_clusters,
    max_iter=max_iterations,
    precompute_distances="auto",
    n_jobs=-1
)

labels = clustering_model.fit_predict(tfidf_all)
print(labels)

X = tfidf_all.todense()

reduced_data = PCA(n_components=pca_num_components).fit_transform(X)
# print reduced_data

fig, ax = plt.subplots()
for index, instance in enumerate(reduced_data):
    # print instance, index, labels[index]
    pca_comp_1, pca_comp_2 = reduced_data[index]
    color = labels_color_map[labels[index]]
    ax.scatter(pca_comp_1, pca_comp_2, c=color)



from sklearn.cluster import KMeans
from sklearn.cluster import MeanShift
from sklearn import manifold
import scipy

### KMeans Clustering, Wörter(term) und TF-IDF-Werte(tfidf) werden als zipped übergeben
# keine sinnvolle Visualisierung, für Beschreibung der eigentlichen Funktion von KMeans, siehe Bericht

X = np.array(zipped)
            
kmeans = KMeans(n_clusters=2)
kmeans.fit(X)
             
center = kmeans.cluster_centers_
labels = kmeans.labels_

#print(center)
#print(labels)

colors = ["g.", "r."]

for i in range(len(X)):
    #print("coordinate:", X[i], "label:", labels[i])
    plt.plot(X[i][0], X[i][1], colors[labels[i]], markersize=10)

plt.scatter(center[:, 0], center[:, 1], marker = "x", s=150, linewidths=5, zorder=10)


### MEANSHIFT ##########################################################
### Dasselbe nur mit MeanShift Clustering, Wörter(term) und TF-IDF-Werte(tfidf) werden als zipped übergeben
# keine sinnvolle Visualisierung, für Beschreibung der eigentlichen Funktion von MeanShift, siehe Bericht

X = np.array(zipped)
ms = MeanShift()
ms.fit(X)
labels = ms.labels_
cluster_centers = ms.cluster_centers_

print(cluster_centers)

n_clusters_ = len(np.unique(labels))

print("Number of estimated clusters:", n_clusters_)

colors = 10*["r.", "g.", "y.", "c.", "k.", "b.", "m."]

#print(colors)
#print(labels)

for i in range(len(X)):
    plt.plot(X[i][0], X[i][1], colors[labels[i]], markersize=10)
    
plt.scatter(cluster_centers[:,0], cluster_centers[:,1],
           marker="x", s=150, linewidths=5, zorder=10)




### MULTIDIMENSIONAL SCALING ############################################

### erste (gescheiterete) Versuche mit Multidimensional Scaling
# übergebene Daten: Liste mit Tupeln, sinnlos, MDS benötigt eigentlich Distanzmatrix

from sklearn.manifold import MDS

tf_array = np.asarray(tf_liste_head)
tf_array = tf_array.reshape(-1, 1)
#array.reshape(-1, 1) if your data has a single feature or array.reshape(1, -1) if it contains a single sample

mds = MDS()
mds2 = mds.fit_transform(tf_array)


X = np.array(mds2)
ms = MeanShift()
ms.fit(X)
labels = ms.labels_
cluster_centers = ms.cluster_centers_

print(cluster_centers)

n_clusters_ = len(np.unique(labels))

print("Number of estimated clusters:", n_clusters_)

colors = 10*["r.", "g.", "y.", "c.", "k.", "b.", "m."]

#print(colors)
#print(labels)

for i in range(len(X)):
    plt.plot(X[i][0], X[i][1], colors[labels[i]], markersize=10)
    
plt.scatter(cluster_centers[:,0], cluster_centers[:,1],
           marker="x", s=150, linewidths=5, zorder=10)


### K-NEAREST NEIGHBORS ###############################################################

## K-Nearest Neighbors ##
# The NearestNeighbors function can be fit on this sparse matrix and will 
# determine the distance between articles based on their TF-IDF values.
# We specify that we want to return the 10 nearest neighbors for each article.

from sklearn.neighbors import NearestNeighbors
# tfidf_all
nbrs = NearestNeighbors(n_neighbors=10).fit(tfidf_matrix)

def get_closest_neighs(name):
    #row = wiki_data.index.get_loc(name)
    distances, indices = nbrs.kneighbors(tfidf_matrix.getrow(name))
    names_similar = pd.Series(indices.flatten()).map(data_frame.reset_index()['Article'])
    result = pd.DataFrame({'distance':distances.flatten(), 'Article':names_similar})
    return result
print(get_closest_neighs(1))



### CHUNKING && VECTORIZING ###############################################################

import matplotlib.pyplot as plt
%pylab inline
import pandas as pd
import numpy as np
from nltk.corpus import stopwords
from nltk.tokenize import word_tokenize
import string
import unicodedata
import sys
from nltk.stem.wordnet import WordNetLemmatizer
from nltk import pos_tag
from nltk.corpus import wordnet
from collections import Counter
from nltk.corpus import state_union
from nltk.tokenize import PunktSentenceTokenizer
from sklearn.feature_extraction.text import CountVectorizer
from sklearn.metrics.pairwise import euclidean_distances
from sklearn.metrics.pairwise import cosine_similarity
import nltk
import numpy as np
from sklearn.feature_extraction.text import CountVectorizer

df = pd.read_pickle(".\dataframe_all")
au_dataframe = df[df["Country"]=="AU"]

n = 500  #Größe der Chunks
list_df = [au_dataframe[i:i+n] for i in range(0,au_dataframe.shape[0],n)] #Teilt das dataframe in kleinere Teile auf
# Output: eine Liste aus Paketen. Jedes Paket enthält eine kleinere Dataframe - Chunk


### Fügt die einzelnen Dataframes wieder zu einem großen zusammen.
olddf = [] 
for n,g in df.groupby("Country"):
    olddf.append(g)
print(olddf)


def splitDataFrameIntoSmaller(article, chunkSize): 
    listOfDf = list()
    numberChunks = len(article) // chunkSize + 1
    for i in range(numberChunks):
        listOfDf.append(article[i*chunkSize:(i+1)*chunkSize])
    return listOfDf
splitDataFrameIntoSmaller(au_dataframe["Article"], 500)

### Versuch 2 / nicht funktionsfähig / ab hier meist gefundene Codefragmente auf Webseiten und diese versucht für 
### unseren Zweck umzumodellieren. Das Vorgehen ist immer gleich. Es gibt eine Methode die das Dataframe in mehrere
### Dataframes aufteilt und diese aufgeteilten dataframes versuchen wir nach und nach durch unsere Countvectorize 
### Methode laufen zu lassen. 

### Konvertiert das Dataframe in einen String
au_dataframe_str = au_dataframe["Article"].to_string()

### Die Methode splittet das Dataframe entsprechend der vorgegebenen Länge in kleinere Dataframes.
def split_text(article, n_words):
        words = au_dataframe_str       
        chunks = []
        current_chunk_words = []
        current_chunk_word_count = 0
        for word in words:
            current_chunk_words.append(word)
            current_chunk_word_count += 1
            if current_chunk_word_count == n_words:
                chunks.append(' '.join(current_chunk_words))
                current_chunk_words = []
                current_chunk_word_count = 0
        chunks.append(' '.join(current_chunk_words) )
        return chunks

chunk_length = 200
chunks = []

for article in au_dataframe_str:
        chunk_counter = 0
        texts = split_text(article, chunk_length)
        for text in texts:
            chunk = {'text': text, 'number': chunk_counter, 'article': article}
            chunks.append(chunk)
            chunk_counter += 1

### Test des Countvektors auf unsere gechunkten Dataframes. 
vectorizer = CountVectorizer()

Vectores = []
for i in chunks:
    Vectores = vectorizer.fit_transform(i)

vocab = vectorizer.get_feature_names()


### Versuch 3 / nicht funktionsfähig
def split_text(article, chunkSize): 
    listOfDf = list()
    numberChunks = len(article) // chunkSize + 1
    for i in range(numberChunks):
        listOfDf.append(article[i*chunkSize:(i+1)*chunkSize])
    return listOfDf
test = split_text(au_dataframe["Article"], 200)


vectorizer = CountVectorizer()
dtm_chunked = []
for i in test:
    dtm_chunked.append(vectorizer.fit_transform(i).todense())
    
vocab = vectorizer.get_feature_names() ###for Schleife ??!?!
#vocab = vectorizer.get_feature_names()
def searched_word(word, articlenumber):
    searched_word = list(vocab).index(word)
    return(Vectores[articlenumber, searched_word])

searched_word("say", 1)


### Versuch 4 / nicht funktionsfähig
def split_text(article, chunk_size):
    size = len(article)
    if size < chunk_size:
        yield iterable
    chunks_nb = int(size / chunk_size)
    iter_ints = range(0, chunks_nb)
    for i in iter_ints:
        j = i * chunk_size
        if i+1 < chunks_nb:
            k = j + chunk_size
            yield iterable[j:k]
        else:
            yield iterable[j:]
test = split_text(au_dataframe["Article"], 200)

vectorizer = CountVectorizer()
Vectores = []
for i in test:
    Vectores = vectorizer.fit_transform(i)


def split_text(nrows, chunk_size):
    return range(1 * chunk_size, (nrows // chunk_size + 1) * chunk_size, chunk_size)
indices = list(chunk_marks(uk_dataframe.shape[0], 100))
print("Marks: {}".format(indices))


def split_text(dfm, chunk_size):
    index = index_marks(dfm.shape[0], chunk_size)
    return np.split(dfm, indices)

chunks = split(dfm, 100)
for c in chunks:
    print("Shape: {}; {}".format(c.shape, c.index))


import numpy as np
from sklearn.feature_extraction.text import CountVectorizer

###Hier bekommen wir immer einen Memory Error, da die Datenanzahl zu hoch ist. 
###Das verwenden von HashingVectorizer() führt ebenfalls zu einem Memory Error.
vectorizer = CountVectorizer(lowercase=False)
#for i in list_df:
    #Vectores.concat(vectorizer.fit_transform(i["Article"]).todense())
#Vectores = vectorizer.fit_transform(au_dataframe["Article"].head(200)).todense()
Vectores = vectorizer.fit_transform([chunk["Article"] for chunk in list_df]).todense()
vocab = vectorizer.get_feature_names()
for f in Vectores: 
   print(euclidean_distances(Vectores[0], f))




vectorizer = CountVectorizer()
dtm_chunked = []
for chunk in list_df:
    dtm_chunked.append(vectorizer.fit_transform(chunk["Article"]).todense())
# matrices concates
dtm = sparse.vstack(dtm_chunked)






import pandas as pd
import re
from nltk import ngrams
from sklearn.feature_extraction.text import CountVectorizer
from scipy import sparse

# our Article model class. Here we're going to rely on its "content" field that
# hold the article's textual content. It's the center of our analysis
from idlm.models import Article

stop_words = [
    # our stop words list goes here then we add a "EOF" word that will be
    # useful when creating vocabulary see (process_vocabulary).
    'EOF',
]

# small function to find all words that we identified as stop/tool words
search_stop_words = re.compile("(%s)" % '|'.join(stop_words) ).search

# Ex: getchunks([0,1,2,3,4,5,6,7], 4) => [[0,1,2,3], [4,5,6,7]]
def getchunks(iterable, chunk_size):
    size = len(iterable)
    if size < chunk_size:
        yield iterable
    chunks_nb = int(size / chunk_size)
    iter_ints = range(0, chunks_nb)
    for i in iter_ints:
        j = i * chunk_size
        if i+1 < chunks_nb:
            k = j + chunk_size
            yield iterable[j:k]
        else:
            yield iterable[j:]

def getngrams(texts):
    _ngrams = dict()
    # This EOF is here because we produce ngrams on a bunch of documents in a
    # single time. So when we will produce our vocabulary after that we want to
    # be able to avoid associating terms that are not really associated.
    allterms = ' EOF '.join(texts).split(' ')
    # create 1-grams, 2-grams and 3-grams and zip() them all.
    for g in zip(ngrams(allterms, 1), ngrams(allterms, 2), ngrams(allterms, 3)):
        for w in map(lambda w: ' '.join(w), g):
            if w not in _ngrams and not search_stop_words(w):
                _ngrams[w] = 1
    return _ngrams

# Creates a vocabulary/dictonnary from a bunch of documents
def process_vocabulary(texts):
    ngrams = getngrams(texts)
    keys = ngrams.keys()
    keys.sort()
    return keys


# Conversion of django objects to a DataFrame
#df = read_frame(Article.objects.all()[:1000])
# Vocabulary creation
vocabulary = process_vocabulary(au_dataframe["Article"])
# Model initialization
model = CountVectorizer(
    ngram_range=(1, 3), analyzer='word', stop_words=stop_words,
    vocabulary=vocabulary
)
dtm_chunked = []
for chunk in getchunks(texts, au_dataframe["Article"]):
    dtm_chunked.append(model.fit_transform(chunk))

# matrices concates
dtm = sparse.vstack(dtm_chunked)







### LEMMATIZING #############################################################

### Lemmatizing
### Diese beispiel Aufrufe zeigen , was passiert, wenn man dem Wort kein korrektes pos_tag zuordnet. 
### Deafault mäßig sind alle Wörter die man mit der lemmatiz Funktion aufruft als Nomen deklariert.
### Durch den Zusatz "pos=""" kann man deklarieren, um welche Wortart es sich handelt.
wordnet_lemmatizer = WordNetLemmatizer()

print(wordnet_lemmatizer.lemmatize("downloading", pos="v"))
print(wordnet_lemmatizer.lemmatize("downloading"))
print(wordnet_lemmatizer.lemmatize("is", pos="v"))
print(wordnet_lemmatizer.lemmatize("is", pos="n"))
print(wordnet_lemmatizer.lemmatize("downloaded", pos="v"))
print(wordnet_lemmatizer.lemmatize("downloaded", pos="n"))
print(wordnet_lemmatizer.lemmatize("say", pos="v"))
print(wordnet_lemmatizer.lemmatize("say", pos="n"))


### Drei verschieden Lemmatizefunktionen die alle funktionieren.

### Die Funktionsweise der Lemmatizefunktionen sind alle relativ ähnlich in ihrer Funktion und
### unterscheiden sich nur in Ihrer Art, wie das richtige pos Tag zu dem jeweiligen Wort ermittelt wird. 
### Die Ermittlung des Pos tags ist relevant und notwenig, da alle Wörter per deafault als Nomen deklariert sind. 
### Sind die Wörter nicht korrekt deklariert sieht man im Code oben, dass der Wortstamm nicht korrekt ermittelt 
### werden kann. Bei den Funktionen wird das Wort als Eingabe benutzt und anschließend in der jeweiligen Methode
### geguckt, welchen Pos tag dieses Wort besitzt. Anschließend wird die Domnination aus Beiden durch die 
### Lemmatize Funktion berechnet. 

### Nr. 1
def get_pos(word):
    w_synsets = wordnet.synsets(word)
    
    pos_counts = Counter()
    pos_counts["n"] = len(  [ item for item in w_synsets if item.pos()=="n"]  )
    pos_counts["v"] = len(  [ item for item in w_synsets if item.pos()=="v"]  )
    pos_counts["a"] = len(  [ item for item in w_synsets if item.pos()=="a"]  )
    pos_counts["r"] = len(  [ item for item in w_synsets if item.pos()=="r"]  )
    
    most_common_pos_list = pos_counts.most_common(3)
    return most_common_pos_list[0][0] 


words = ["mice"]
lemmatizer = WordNetLemmatizer()

for word in words:
    print(lemmatizer.lemmatize(word, get_pos(word)))



### Nr. 2
def get_pos(treebank_tag):

    if treebank_tag.startswith("J"):
        return wordnet.ADJ
    elif treebank_tag.startswith("V"):
        return wordnet.VERB
    elif treebank_tag.startswith("N"):
        return wordnet.NOUN
    elif treebank_tag.startswith("R"):
        return wordnet.ADV
    else:
        return None 


lemmatizer = WordNetLemmatizer()
tagged = pos_tag(word_tokenize("mice"))


for word, tag in tagged:
    wntag = get_pos(tag)
    if wntag is None:
        lemma = lemmatizer.lemmatize(word) 
    else:
        lemma = lemmatizer.lemmatize(word, pos=wntag) 
    print(lemma)


### Nr. 3
lemmatizer = WordNetLemmatizer()
words = "mice"

for word, tag in pos_tag(word_tokenize(words)):
    wntag = tag[0].lower()
    wntag = wntag if wntag in ['a', 'r', 'n', 'v'] else None
    if not wntag:
             lemmatized = words
    else:
             lemmatized = wnl.lemmatize(words, wntag)
    print(lemmatized)